<template>
    <b-container>
        <Pie
        :chart-options="chartOptions"
        :chart-data="chartData"
        :chart-id="chartId"
        :dataset-id-key="datasetIdKey"
        :plugins="plugins"
        :css-classes="cssClasses"
        :styles="styles"
        :width="width"
        :height="height"
        />
    </b-container>
</template>

<script>
import { Pie } from 'vue-chartjs'
import { Chart as ChartJS, Title, Tooltip, Legend, ArcElement, CategoryScale } from 'chart.js'
ChartJS.register(Title, Tooltip, Legend, ArcElement, CategoryScale)

export default {
    name: 'PieChartComponent',
    components: { Pie },
    props: {
        chartId: {
            type: String,
            default: 'pie-chart'
        },
        datasetIdKey: {
            type: String,
            default: 'label'
        },
        width: {
            type: Number,
            default: 100
        },
        height: {
            type: Number,
            default: 50
        },
        cssClasses: {
            default: '',
            type: String
        },
        styles: {
            type: Object,
            default: () => {}
        },
        plugins: {
            type: Object,
            default: () => {}
        }
    },
    data () {
        return {
            chartData: tweets.data,
            chartOptions: tweets.options
        }
    },
    mounted() {
        this.$root.$on("getDataPieChart", sentiment_array => {
            tweets.data.datasets[0].data = sentiment_array
            this.chartData = tweets.data
        })
    }
}


let tweets = {
    data: {
        labels: ["Positivo", "Neutro", "Negativo"],
        datasets: [ {
            borderWidth: 0,
            backgroundColor: ["#4ca83b", "#e0c503", "#f00a03"],
            data: [0,0,0],
            label: "Sentimento dei tweets"
        } ]
    },
    options: {
        responsive: true,
        maintainAspectRatio: false,
        plugins: {
            legend: { display: true }
        }
    }
}
</script>
